﻿(function () {
    "use strict";

    angular.module("portalApp.directives")
        .directive("gnIgnoreDirty", ignoreDirty);

    ignoreDirty.$inject = [];

    //
    // By setting this directive on a control, it will prevent it to alter the dirty status of the form.
    //
    function ignoreDirty() {
        return {
            restrict: 'A',
            require: 'ngModel',
            link: function (scope, elm, attrs, ctrl) {
                ctrl.$setPristine = function () { }; // prevent form.$setPrestine() from resetting the flag
                ctrl.$pristine = false; // here's the trick: by setting the prestine to false immediately prevents the dirty flag to ever been set.
            }
        }
    }
})();