﻿(function () {
    "use strict";

    angular.module('portalApp.directives')
        .directive('numberUnsignedInteger', numberUnsignedInteger);

    function numberUnsignedInteger() {
        return {
            restrict: 'A',
            link: function (scope, element, attributes) {

                element.on('keypress', function (event) {
                    if (!isIntegerChar())
                        event.preventDefault();

                    function isIntegerChar() {
                        // Apply the pattern if specified. Otherwise allow only unsigned integer values.
                        if (attributes.pattern === undefined)
                            return /[0-9]/.test(String.fromCharCode(event.which));
                        else
                            return attributes.pattern.test(String.fromCharCode(event.which));
                    }
                });

                element.on('paste', function (event) {
                    // Disable paste
                    event.preventDefault();
                });

            }
        }
    }
})();
