﻿(function () {
    "use strict";

    angular.module('portalApp.directives')
        .directive('zxPasswordMeter', zxPasswordMeter);
    
    function zxPasswordMeter() {
        return {
            scope: {
                value: "@",
                max: "@?"
            },
            template:   '<div class="progress password-meter">' +
                            '<div class="progress-bar progress-bar-{{ progress }}" role="progressbar" aria-valuenow="value" aria-valuemin="0" aria-valuemax="100" ng-attr-style="width:{{width}}%">' +
                            '</div>' +
                        '</div>' +
                        '<div class="help-block has-{{ help }}"translate>{{ text }} <i class="ico-sc-info pull-right text-primary"></i>' +
                        '</div>',
            link: function (scope) {
                scope.progress = 'danger'; // for the "progress-bar-..." attribute
                scope.help = 'error'; // for the "has-..." attribute
                scope.width = 0;
                scope.max = (!scope.max) ? 100 : scope.max;

                scope.$watch('value', function (newValue) {
                    if (newValue === "")
                        return;
                    var obj = JSON.parse(newValue);
                    scope.width = obj.score / scope.max * 100;

                    if (obj.score === 0) {
                        scope.progress = 'danger';
                        scope.help = 'error';
                        scope.text = 'STE_LABEL_PasswordMeter_VeryWeak';
                    }
                    else if (obj.score <= 1) {
                        scope.progress = 'danger';
                        scope.help = 'error';
                        scope.text = 'STE_LABEL_PasswordMeter_Weak';
                    }
                    else if (obj.score <= 2) {
                        scope.progress = 'warning';
                        scope.help = 'warning';
                        scope.text = 'STE_LABEL_PasswordMeter_Medium';
                    }
                    else if (obj.score <= 3) {
                        scope.progress = 'success';
                        scope.help = 'success';
                        scope.text = 'STE_LABEL_PasswordMeter_Strong';
                    }
                    else {
                        scope.progress = 'success';
                        scope.help = 'success';
                        scope.text = 'STE_LABEL_PasswordMeter_VeryStrong';
                    }
                });
            }
        }
    }
})();