﻿(function () {
    "use strict";

    angular
        .module("portalApp.factories")
        .factory("focusFactory", focusFactory);

    focusFactory.$inject = ["$timeout", "$window"];

    function focusFactory($timeout, $window) {

        return {
            doFocus: doFocus
        };

        function doFocus(id) {
            // timeout makes sure that it is invoked after any other event has been triggered.
            // e.g. click events that need to run before the focus or
            // inputs elements that are in a disabled state but are enabled when those events
            // are triggered.
            $timeout(function() {
                var element = $window.document.getElementById(id);
                if (element)
                    element.focus();
                else {
                    throw "element not found with id:" + id;
                }
            });
        };
    }
})();