﻿(function () {
    "use strict";

    angular.module("portalApp.filters")
    .filter("bytes", bytesFilter);

    bytesFilter.$inject = ["$translate"];

    function bytesFilter($translate)
    {
        return function (bytes, precision) {
            if (bytes === 0)
                return $translate.instant("STE_LABEL_ZeroBytes");

            if (isNaN(parseFloat(bytes)) || !isFinite(bytes))
                return "-";

            if (typeof precision === "undefined")
                precision = 1;

            var bytesAbbr = $translate.instant("STE_LABEL_BytesAbbreviation");

            var units = [$translate.instant("STE_LABEL_BytesLowerCase"),
                "Ki" + bytesAbbr,
                "Mi" + bytesAbbr,
                "Gi" + bytesAbbr,
                "Ti" + bytesAbbr,
                "Pi" + bytesAbbr];
            var number = Math.floor(Math.log(bytes) / Math.log(1024));
            var val = (bytes / Math.pow(1024, Math.floor(number))).toFixed(precision);

            return (val.match(/\.0*$/) ? val.substr(0, val.indexOf(".")) : val) + " " + units[number];
        }
    }
})();
