﻿//
// Filter used to display an elapsed time in the simplest units possible
// Returned string is localized.
//
// <params name="referenceTime">the Date for which the elapsed time since 'now' is requested</param>
// <params name="now">the value of now (should be > 'referenceTime')</param>
//
(function () {
    "use strict";

    angular.module("portalApp.filters")
    .filter("elapsedTime", defineElapsedTimeFilter);

    function defineElapsedTimeFilter()
    {
        return function (val, referenceTime, lang) {
            if (!(val && referenceTime)) return "-";

            var r = (typeof (referenceTime) === "string" ) ? new Date(referenceTime) : referenceTime;
            var v = (typeof (val) === "string") ? new Date(val) : val;

            if (!(r instanceof Date)) return "-";
            if (!(v instanceof Date)) return "-";

            if (v.getFullYear() < 2000) return "-";

            // Localized answer is ensured by calling moment.locale(string: 'fr') when starting the application
            return moment(v).from(moment(r));
        }
    }
})();