﻿// Used to expand the input field area (and space the accompagnating label) when it receives the focus

//**************************** FUNCTION INPUT FILL ********************************/
function addclassfilled(obj) {
    if (obj.value) {
        $(obj).addClass('filled');
        $(obj).prev('label').addClass('filled');
        $(obj).parent('.input-group').prev('label').addClass('filled');
        $(obj).prev('label').removeClass('focus');
        $(obj).parent('.input-group').prev('label').removeClass('focus');

    } else {
        $(obj).removeClass('filled');
        $(obj).prev('label').removeClass('filled focus');
        $(obj).parent('.input-group').prev('label').removeClass('filled focus');
    }
}

//**************************** FUNCTION FIELD ERROR ********************************/
function field_error(obj, error) {
    var content = $(obj).next('.input-placeholder').html();
    $(obj).addClass('has-error');
    $(obj).next('.input-placeholder').addClass('has-error');
    $(obj).next('.input-placeholder').html(error);
}

//******* Set filled and focus classes on every input and textarea based on its contents ********/

// Add/remove filled/focus classes on all input elements
$('input').each(function () {
    addclassfilled(this);
});

// Add/remove filled/focus classes on all text area elements
$('textarea').each(function () {
    addclassfilled(this);
});

// Set input BLUR callback
$('input').blur(function () {
    addclassfilled(this);
});

//  Set input FOCUS callback
$('input').focus(function () {
    $(this).addClass('filled');
    $(this).prev('label').addClass('filled focus');
    $(this).parent('.input-group').prev('label').addClass('filled focus');
});

// Set text area BLUR callback
$('textarea').blur(function () {
    addclassfilled(this);
});

// Set text area FOCUS callback
$('textarea').focus(function () {
    $(this).addClass('filled');
    $(this).prev('label').addClass('filled focus');
});
