﻿(function () {
    "use strict";

    angular
        .module("portalApp.testing", [])
        .factory("mockFactory", mockFactory);

    mockFactory.$inject = ["portalService", "$q"];

    function mockFactory(portalService, $q) {

        var sandbox = undefined;
        var stubs = {};

        return {
            setSandbox: setSandbox,
            stubGetUserConfig: stubGetUserConfig,
            stubGetRegionOfInterest: stubGetRegionOfInterest,
            stubGetProperties: stubGetProperties,
            stubSetUserConfig: stubSetUserConfig,
            stubPostRegionOfInterest: stubPostRegionOfInterest
        };

        function setSandbox(_sandbox) {
            sandbox = _sandbox;
        }

        function stubGetUserConfig(data, result) {
            var d = $q.defer();
            var dto = data ? data : { data: {} };
            if (result || result === undefined)
                d.resolve(dto);
            else
                d.reject();
            return createStub("getUserConfig").returns(d.promise);
        }

        function stubGetRegionOfInterest(data, result) {
            var d = $q.defer();
            var dto = data ? data : { data: {} };
            if (result || result === undefined)
                d.resolve(dto);
            else
                d.reject();
            return createStub("getRegionOfInterest").returns(d.promise);
        }

        function stubGetProperties(data, result) {
            var d = $q.defer();
            var dto = data ? data : { data: {} };
            if (result || result === undefined)
                d.resolve(dto);
            else
                d.reject();
            return createStub("getProperties").returns(d.promise);
        }

        function stubSetUserConfig(data, result) {
            var d = $q.defer();
            var dto = data ? data : { data: {} };
            if (result || result === undefined)
                d.resolve(dto);
            else
                d.reject();
            return createStub("setUserConfig").returns(d.promise);
        }

        function stubPostRegionOfInterest(data, result) {
            var d = $q.defer();
            var dto = data ? data : { data: {} };
            if (result || result === undefined)
                d.resolve(dto);
            else
                d.reject();
            return createStub("postRegionOfInterest").returns(d.promise);
        }

        // private 

        // safely create or recreate an existing stub
        function createStub(name) {
            if (stubs[name]) {
                stubs[name].restore();
                stubs[name] = undefined;
            }

            stubs[name] = sandbox.stub(portalService, name);
            return stubs[name];
        }
    }
})();
